> ## Documentation Index
> Fetch the complete documentation index at: https://perplexity-cf-proxied-beta.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Async Chat Completion

> Submit an asynchronous chat completion request.



## OpenAPI

````yaml post /async/chat/completions
openapi: 3.1.0
info:
  title: Perplexity AI API
  description: Perplexity AI API
  version: 1.0.0
servers:
  - url: https://api.perplexity.ai
    description: Perplexity AI API
security: []
paths:
  /async/chat/completions:
    post:
      summary: Create Async Chat Completion
      description: Submit an asynchronous chat completion request.
      operationId: create_async_chat_completions_async_chat_completions_post
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AsyncApiChatCompletionsRequest'
            example:
              request:
                model: sonar-deep-research
                messages:
                  - role: <string>
                    content: <string>
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AsyncApiChatCompletionsResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    AsyncApiChatCompletionsRequest:
      properties:
        request:
          $ref: '#/components/schemas/ApiChatCompletionsRequest'
        idempotency_key:
          anyOf:
            - type: string
            - type: 'null'
          title: Idempotency Key
      type: object
      required:
        - request
      title: AsyncApiChatCompletionsRequest
    AsyncApiChatCompletionsResponse:
      properties:
        id:
          type: string
          title: Id
        model:
          type: string
          title: Model
        created_at:
          type: integer
          title: Created At
        started_at:
          anyOf:
            - type: integer
            - type: 'null'
          title: Started At
        completed_at:
          anyOf:
            - type: integer
            - type: 'null'
          title: Completed At
        response:
          anyOf:
            - $ref: '#/components/schemas/CompletionResponse'
            - type: 'null'
        failed_at:
          anyOf:
            - type: integer
            - type: 'null'
          title: Failed At
        error_message:
          anyOf:
            - type: string
            - type: 'null'
          title: Error Message
        status:
          $ref: '#/components/schemas/AsyncProcessingStatus'
      type: object
      required:
        - id
        - model
        - created_at
        - status
      title: AsyncApiChatCompletionsResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ApiChatCompletionsRequest:
      properties:
        max_tokens:
          anyOf:
            - type: integer
              maximum: 128000
              exclusiveMinimum: 0
            - type: 'null'
          title: Max Tokens
        model:
          type: string
          title: Model
          description: Model to use, for example, sonar-pro
          enum:
            - sonar
            - sonar-pro
            - sonar-deep-research
            - sonar-reasoning-pro
        stream:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Stream
          default: false
        stop:
          anyOf:
            - type: string
            - items:
                type: string
              type: array
            - type: 'null'
          title: Stop
        temperature:
          anyOf:
            - type: number
              minimum: 0
              maximum: 2
            - type: 'null'
          title: Temperature
          description: >-
            Controls randomness in the response. Higher values make output more
            random. Range: 0-2
        top_p:
          anyOf:
            - type: number
              minimum: 0
              maximum: 1
            - type: 'null'
          title: Top P
          description: Nucleus sampling parameter. Controls diversity via nucleus sampling
        response_format:
          anyOf:
            - $ref: '#/components/schemas/ResponseFormatText'
            - $ref: '#/components/schemas/ResponseFormatJSONSchema'
            - type: 'null'
          title: Response Format
          description: >-
            Optional. Controls the output format. Omit for default text output.
            Set `type` to `json_schema` for structured output.
          discriminator:
            propertyName: type
            mapping:
              text:
                $ref: '#/components/schemas/ResponseFormatText'
              json_schema:
                $ref: '#/components/schemas/ResponseFormatJSONSchema'
        messages:
          items:
            $ref: '#/components/schemas/ChatMessage-Input'
          type: array
          title: Messages
        web_search_options:
          $ref: '#/components/schemas/WebSearchOptions'
        search_mode:
          anyOf:
            - type: string
              enum:
                - web
                - academic
                - sec
            - type: 'null'
          title: Search Mode
        return_images:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Return Images
        return_related_questions:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Return Related Questions
        enable_search_classifier:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Enable Search Classifier
        disable_search:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Disable Search
        search_domain_filter:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Search Domain Filter
        search_language_filter:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Search Language Filter
        search_recency_filter:
          anyOf:
            - type: string
              enum:
                - hour
                - day
                - week
                - month
                - year
            - type: 'null'
          title: Search Recency Filter
        search_after_date_filter:
          anyOf:
            - type: string
            - type: 'null'
          title: Search After Date Filter
        search_before_date_filter:
          anyOf:
            - type: string
            - type: 'null'
          title: Search Before Date Filter
        last_updated_before_filter:
          anyOf:
            - type: string
            - type: 'null'
          title: Last Updated Before Filter
        last_updated_after_filter:
          anyOf:
            - type: string
            - type: 'null'
          title: Last Updated After Filter
        image_format_filter:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Image Format Filter
        image_domain_filter:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Image Domain Filter
        stream_mode:
          type: string
          enum:
            - full
            - concise
          title: Stream Mode
          default: full
        reasoning_effort:
          anyOf:
            - type: string
              enum:
                - minimal
                - low
                - medium
                - high
            - type: 'null'
          title: Reasoning Effort
        language_preference:
          anyOf:
            - type: string
            - type: 'null'
          title: Language Preference
      type: object
      required:
        - model
        - messages
      title: ApiChatCompletionsRequest
    CompletionResponse:
      properties:
        id:
          type: string
          title: Id
        model:
          type: string
          title: Model
        created:
          type: integer
          title: Created
        usage:
          anyOf:
            - $ref: '#/components/schemas/UsageInfo'
            - type: 'null'
        object:
          type: string
          title: Object
          default: chat.completion
        choices:
          items:
            $ref: '#/components/schemas/Choice'
          type: array
          title: Choices
        citations:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Citations
        search_results:
          anyOf:
            - items:
                $ref: '#/components/schemas/ApiPublicSearchResult'
              type: array
            - type: 'null'
          title: Search Results
        images:
          anyOf:
            - items:
                $ref: '#/components/schemas/ImageResult'
              type: array
            - type: 'null'
          title: Images
          description: Array of images returned when return_images is true
        related_questions:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Related Questions
          description: >-
            Array of related questions returned when return_related_questions is
            true
      type: object
      required:
        - id
        - model
        - created
        - choices
      title: CompletionResponse
    AsyncProcessingStatus:
      type: string
      enum:
        - CREATED
        - IN_PROGRESS
        - COMPLETED
        - FAILED
      title: AsyncProcessingStatus
      description: Status enum for async processing.
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    ResponseFormatText:
      properties:
        type:
          type: string
          const: text
          title: Type
          description: Must be `text`.
      type: object
      required:
        - type
      title: ResponseFormatText
    ResponseFormatJSONSchema:
      description: Constrains the model output to match the provided JSON schema.
      properties:
        type:
          type: string
          const: json_schema
          title: Type
          description: Must be `json_schema`.
        json_schema:
          $ref: '#/components/schemas/JSONSchema'
      type: object
      required:
        - type
        - json_schema
      title: ResponseFormatJSONSchema
    ChatMessage-Input:
      properties:
        role:
          $ref: '#/components/schemas/ChatMessageRole'
        content:
          anyOf:
            - type: string
            - items:
                anyOf:
                  - $ref: '#/components/schemas/ChatMessageContentTextChunk'
                  - $ref: '#/components/schemas/ChatMessageContentImageChunk'
                  - $ref: '#/components/schemas/ChatMessageContentFileChunk'
                  - $ref: '#/components/schemas/ChatMessageContentPDFChunk'
                  - $ref: '#/components/schemas/ChatMessageContentVideoChunk'
              type: array
              title: Structured Content
            - type: 'null'
          title: Content
      type: object
      required:
        - role
        - content
      title: ChatMessage
    WebSearchOptions:
      properties:
        search_context_size:
          type: string
          enum:
            - low
            - medium
            - high
          title: Search Context Size
          default: low
        search_type:
          anyOf:
            - type: string
              enum:
                - fast
                - pro
                - auto
            - type: 'null'
          title: Search Type
        user_location:
          anyOf:
            - $ref: '#/components/schemas/UserLocation'
            - type: 'null'
        image_results_enhanced_relevance:
          type: boolean
          title: Image Results Enhanced Relevance
          default: false
      type: object
      title: WebSearchOptions
    UsageInfo:
      properties:
        prompt_tokens:
          type: integer
          title: Prompt Tokens
        completion_tokens:
          type: integer
          title: Completion Tokens
        total_tokens:
          type: integer
          title: Total Tokens
        search_context_size:
          anyOf:
            - type: string
            - type: 'null'
          title: Search Context Size
        citation_tokens:
          anyOf:
            - type: integer
            - type: 'null'
          title: Citation Tokens
        num_search_queries:
          anyOf:
            - type: integer
            - type: 'null'
          title: Num Search Queries
        reasoning_tokens:
          anyOf:
            - type: integer
            - type: 'null'
          title: Reasoning Tokens
        cost:
          $ref: '#/components/schemas/Cost'
      type: object
      required:
        - prompt_tokens
        - completion_tokens
        - total_tokens
        - cost
      title: UsageInfo
    Choice:
      properties:
        index:
          type: integer
          title: Index
        finish_reason:
          anyOf:
            - type: string
              enum:
                - stop
                - length
            - type: 'null'
          title: Finish Reason
        message:
          $ref: '#/components/schemas/ChatMessage-Output'
        delta:
          $ref: '#/components/schemas/ChatMessage-Output'
      type: object
      required:
        - index
        - message
        - delta
      title: Choice
    ApiPublicSearchResult:
      properties:
        title:
          type: string
          title: Title
        url:
          type: string
          title: Url
        date:
          anyOf:
            - type: string
            - type: 'null'
          title: Date
        last_updated:
          anyOf:
            - type: string
            - type: 'null'
          title: Last Updated
        snippet:
          type: string
          title: Snippet
          default: ''
        source:
          type: string
          enum:
            - web
            - attachment
          title: Source
          default: web
      type: object
      required:
        - title
        - url
      title: ApiPublicSearchResult
    ImageResult:
      properties:
        image_url:
          type: string
          title: Image Url
          description: URL of the image
        origin_url:
          type: string
          title: Origin Url
          description: Original URL where the image was found
        title:
          type: string
          title: Title
          description: Title or description of the image
        width:
          type: integer
          title: Width
          description: Width of the image in pixels
        height:
          type: integer
          title: Height
          description: Height of the image in pixels
      type: object
      required:
        - image_url
        - origin_url
        - title
        - width
        - height
      title: ImageResult
    JSONSchema:
      properties:
        schema:
          additionalProperties: true
          type: object
          title: Schema
        name:
          anyOf:
            - type: string
            - type: 'null'
          title: Name
          default: schema
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        strict:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Strict
          default: true
      type: object
      required:
        - schema
      title: JSONSchema
    ChatMessageRole:
      type: string
      enum:
        - system
        - user
        - assistant
        - tool
      title: ChatMessageRole
      description: Chat roles enum
    ChatMessageContentTextChunk:
      properties:
        type:
          type: string
          const: text
          title: Type
        text:
          type: string
          title: Text
      type: object
      required:
        - type
        - text
      title: ChatMessageContentTextChunk
    ChatMessageContentImageChunk:
      properties:
        type:
          type: string
          const: image_url
          title: Type
        image_url:
          anyOf:
            - $ref: '#/components/schemas/URL'
            - type: string
          title: Image Url
      type: object
      required:
        - type
        - image_url
      title: ChatMessageContentImageChunk
    ChatMessageContentFileChunk:
      properties:
        type:
          type: string
          const: file_url
          title: Type
        file_url:
          anyOf:
            - $ref: '#/components/schemas/URL'
            - type: string
          title: File Url
        file_name:
          anyOf:
            - type: string
            - type: 'null'
          title: File Name
      type: object
      required:
        - type
        - file_url
      title: ChatMessageContentFileChunk
    ChatMessageContentPDFChunk:
      properties:
        type:
          type: string
          const: pdf_url
          title: Type
        pdf_url:
          anyOf:
            - $ref: '#/components/schemas/URL'
            - type: string
          title: Pdf Url
      type: object
      required:
        - type
        - pdf_url
      title: ChatMessageContentPDFChunk
    ChatMessageContentVideoChunk:
      properties:
        type:
          type: string
          const: video_url
          title: Type
        video_url:
          anyOf:
            - $ref: '#/components/schemas/VideoURL'
            - type: string
          title: Video Url
      type: object
      required:
        - type
        - video_url
      title: ChatMessageContentVideoChunk
    UserLocation:
      properties:
        latitude:
          anyOf:
            - type: number
            - type: 'null'
          title: Latitude
        longitude:
          anyOf:
            - type: number
            - type: 'null'
          title: Longitude
        country:
          anyOf:
            - type: string
            - type: 'null'
          title: Country
        city:
          anyOf:
            - type: string
            - type: 'null'
          title: City
        region:
          anyOf:
            - type: string
            - type: 'null'
          title: Region
      type: object
      title: UserLocation
    Cost:
      properties:
        input_tokens_cost:
          type: number
          title: Input Tokens Cost
        output_tokens_cost:
          type: number
          title: Output Tokens Cost
        reasoning_tokens_cost:
          anyOf:
            - type: number
            - type: 'null'
          title: Reasoning Tokens Cost
        request_cost:
          anyOf:
            - type: number
            - type: 'null'
          title: Request Cost
        citation_tokens_cost:
          anyOf:
            - type: number
            - type: 'null'
          title: Citation Tokens Cost
        search_queries_cost:
          anyOf:
            - type: number
            - type: 'null'
          title: Search Queries Cost
        total_cost:
          type: number
          title: Total Cost
      type: object
      required:
        - input_tokens_cost
        - output_tokens_cost
        - total_cost
      title: Cost
    ChatMessage-Output:
      properties:
        role:
          $ref: '#/components/schemas/ChatMessageRole'
        content:
          anyOf:
            - type: string
            - items:
                anyOf:
                  - $ref: '#/components/schemas/ChatMessageContentTextChunk'
                  - $ref: '#/components/schemas/ChatMessageContentImageChunk'
                  - $ref: '#/components/schemas/ChatMessageContentFileChunk'
                  - $ref: '#/components/schemas/ChatMessageContentPDFChunk'
                  - $ref: '#/components/schemas/ChatMessageContentVideoChunk'
              type: array
              title: Structured Content
            - type: 'null'
          title: Content
      type: object
      required:
        - role
        - content
      title: ChatMessage
    URL:
      properties:
        url:
          type: string
          title: Url
      type: object
      required:
        - url
      title: URL
    VideoURL:
      properties:
        url:
          type: string
          title: Url
        frame_interval:
          anyOf:
            - type: string
            - type: integer
          title: Frame Interval
          default: 25
      type: object
      required:
        - url
      title: VideoURL
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````